# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "commodity_id": "commodityID",
        "hs_code": "hsCode",
        "commodity_duty": "commodityDuty",
        "total_commodity_tax_and_fee": "totalCommodityTaxAndFee",
        "commodity_vat": "commodityVAT",
        "total_commodity_duty_and_tax": "totalCommodityDutyAndTax",
        "commodity_currency_code": "commodityCurrencyCode",
        "is_calculable": "isCalculable",
    }
)
class ResponseShipmentItems(BaseModel):
    """ResponseShipmentItems

    :param commodity_id: Specifies the commodity ID.
    :type commodity_id: str
    :param hs_code: Specifies the HTS code of the commodity.
    :type hs_code: str
    :param commodity_duty: Duty amount for this commodity.
    :type commodity_duty: float
    :param total_commodity_tax_and_fee: Total tax and other fees for this commodity (excluding commodity duty and VAT)., defaults to None
    :type total_commodity_tax_and_fee: float, optional
    :param commodity_vat: VAT amount for this commodity.
    :type commodity_vat: float
    :param total_commodity_duty_and_tax: Sum of commodity duty, VAT, tax, and other fees for this commodity.
    :type total_commodity_duty_and_tax: float
    :param commodity_currency_code: Specifies the currency code used for commodity's price.
    :type commodity_currency_code: str
    :param is_calculable: True/False. Indicates if Landed Cost can successful calculated for this commodity.
    :type is_calculable: bool
    """

    def __init__(
        self,
        commodity_id: str,
        hs_code: str,
        commodity_duty: float,
        commodity_vat: float,
        total_commodity_duty_and_tax: float,
        commodity_currency_code: str,
        is_calculable: bool,
        total_commodity_tax_and_fee: float = None,
    ):
        self.commodity_id = commodity_id
        self.hs_code = hs_code
        self.commodity_duty = commodity_duty
        if total_commodity_tax_and_fee is not None:
            self.total_commodity_tax_and_fee = total_commodity_tax_and_fee
        self.commodity_vat = commodity_vat
        self.total_commodity_duty_and_tax = total_commodity_duty_and_tax
        self.commodity_currency_code = commodity_currency_code
        self.is_calculable = is_calculable
